<?php
/**
 * Created by PhpStorm.
 * User: Noa
 * Date: 9/11/2016
 * Time: 1:30 PM
 */

namespace Fr\RetailMeNot\Cloud\StateMachine;

class State extends Element {

    /**
     * @var array
     */
    private $potentialTransitions = array();

    private $nextState = array();

    public function addOutputTransition(Transition $transition, State $nextState) {

        $this->potentialTransitions[] = $transition;
        $this->nextState[$transition->getId()] = $nextState;
    }

    /**
     * @return array
     */
    public function getOutputTransitions() {
        return $this->potentialTransitions;
    }

    /**
     * @param string $transitionName
     * @return State
     */
    public function getnextState($transitionName) {
        return $this->nextState[$transitionName];
    }

}
